/*
 * Prototypes for debugging routines
 */
#if !defined(DEBUG_H)
#define DEBUG_H

#if defined(ENABLE_DEBUG)
int DBG_Open(char *file);
int DBG_Disable(char *key);
int DBG_Enable(char *key);
int DBG_Print(char *key, char *format, ...);
int DBG_Close(void);
int DBG_IsEnabled(char *key);

#else
inline int DBG_Open(char *file);
inline int DBG_Disable(char *key);
inline int DBG_Enable(char *key);
inline int DBG_Print(char *key, char *format, ...);
inline int DBG_Close(void);
inline int DBG_IsEnabled(char *key);

#endif

#define DBG_NullCheck(x) ((x)?(x):("[NULL]"))

#endif
